/****************************************************************************

    PROGRAM: MDExtern.c
 
    FUNCTIONS: Beispiel fr eine Externe DLL in	MultiDec

 
*******************************************************************************/
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>        /* atoi                                  */
#include <sys/types.h>
#include <sys/stat.h>

#include "MDExtern.h"
#include "resource.h"



BOOL APIENTRY DllAbout(HWND hDlg,UINT message,UINT wParam,LONG lParam);
void Get_Current_Programm( struct TProgrammNummer *TPNr );
void Set_Current_Programm( int Nummer );
void Set_Current_Transponder(struct TTransponder *Transponder);
void Get_Current_Transponder(struct TTransponder *Transponder);
void Get_Programm_Detail( struct TProgramm *TPtg);
void Set_Programm_Detail( struct TProgramm *TPtg);
void Save_Programm_Liste( void );
void Rescan_Programm( struct TProgramm *TPtg );
void Filter_0_Irq_Proc( int MyFilter, int DatenLaenge , unsigned char *Daten);
void Start_Log( void );
void Stop_Log( void );
void Start_OSD_Key_Demo( void );
void Start_OSD_Time_Demo( void );
void Create_Osd_Thread( LPTHREAD_START_ROUTINE ThreadProzess);

void OSD_CreateWindow(unsigned char Bits, unsigned short x1,unsigned short y1,unsigned short x2,unsigned short y2,BOOL Has_KeyBoard_Input);
void OSD_Draw_Block( unsigned short x,unsigned short y,unsigned short SizeX,unsigned short SizeY,unsigned short Color);
void OSD_Set_Font( unsigned short Typ,unsigned short Fg_Color,unsigned short Bg_Color);
void OSD_Write_Text( unsigned short x,unsigned short y,unsigned char *Text);
void OSD_Close( void );


/*******************************************************************************/


BOOL WINAPI DllMain (HINSTANCE hDLL, DWORD dwReason, LPVOID lpReserved)
{
static BOOL ret;            
char Name[256];

  switch (dwReason)
  {
    case DLL_PROCESS_ATTACH:
        DLLInstance=hDLL;
        GetModuleFileName (NULL, (LPTSTR) Name, 256);
        // Aufrufende Programm in Name
		break;

    case DLL_THREAD_ATTACH:
      break;

    case DLL_THREAD_DETACH:
    case DLL_PROCESS_DETACH:
      break;
  }

return TRUE;
}


/****************************************************************************
    FUNCTION:  WEP(int)

    PURPOSE:  Performs cleanup tasks when the DLL is unloaded.  WEP() is
              called automatically by Windows when the DLL is unloaded (no
              remaining tasks still have the DLL loaded).  It is strongly
              recommended that a DLL have a WEP() function, even if it does
              nothing but returns success (1), as in this example.

*******************************************************************************/

BOOL CALLBACK  _WEP(BOOL fSystemExit)
{

    return TRUE;
}



/****************************************************************************
    FUNCTION:  void On_Start(HINSTANCE MDInstance, HWND MDWnd, BOOL Log_Set, int DLL_ID, char *My_Hot_Key, char *Api_Version, int *Keep_me_running) )

    PURPOSE:  Wird aufgerufen nachdem die DVBs-Karte initialisiert worden ist

*******************************************************************************/

void On_Start(HINSTANCE MDInstance, HWND MDWnd, BOOL Log_Set, int DLL_ID, char *My_Hot_Key, char *Api_Version, int *Keep_me_running)
{
	
	int i;
	char Zeile[256];

	MultiDecInstance=MDInstance;
	MultiDecWindow=MDWnd;
    MultiDecLog = Log_Set;
    MultiDec_DLL_ID=DLL_ID;

	*My_Hot_Key='G';   // oder 0x00 fr Kein HotKey

	sprintf(Zeile,"DLL-Aufforderung zum initialisieren ( DVB-OK )\n\n%s\n\nSoll ich weiter laufen ??",Api_Version);

	// Check the Version of the API
	// MD-API Version 01.02 Root <Bytes of RootFile>
	//
	// First  ID : (at the moment 01 ) Major Version -> Some old calls changed < please be carefull !!  >
    //             Tests needed 
	//
	// Second ID : (at the moment 02 ) Minor Version -> Only extensions no changes in calls which might affect the application
    //             Application should run 
    //
    // and somebody told me, that it might be nessesary to know something about the root-file
    // ( I only can offer the size at the moment )


    if ( MessageBox(MultiDecWindow,Zeile,"MultiDec DLL-DEMO",MB_YESNO) == IDYES ) *Keep_me_running = 0; // Im fine 
	 else *Keep_me_running = 1;  // Not able to run 
}

/****************************************************************************
    FUNCTION:  void On_Exit(  )

    PURPOSE:  Wird zum beenden von MultiDec aufgerufen 

*******************************************************************************/

void On_Exit(HINSTANCE MDInstance, HWND MDWnd, BOOL Log_Set)
{
	if ( OSD_KEY_EVENT == NULL ) CloseHandle(OSD_KEY_EVENT);
    MessageBox(MultiDecWindow,"DLL-Aufforderung zum beenden ","MultiDec DLL-DEMO",MB_OK);
}

void On_Send_Dll_ID_Name(char *Name)
{
// An dieser Funktion idetifiziert MultiDec seine Externen DLLs.
// Eine Dll wird angezogen, wenn diese Funktion drinnen ist.
// Der Name ist der Menname der DLL, der in MD gesetzt werden soll.
	
	strcpy(Name,"Demo-API");
};


void On_Menu_Select(unsigned int MenuID )
{
// Entspricht in etwa der Command_Loop 
// Im Men drfen nur IDs von 40000 bis 41000 verwendet werden.
// Bei mehreren DLLs MUSS dieser Wert eindeutig sein
// Sollte aber bei 1000 mglichen Mens kein Problem sein
char Zeile[128];

struct TTransponder TPtp;
struct TProgrammNummer TPnr;
struct TProgramm TPtg;
    
	
	if ( MenuID == 40000 ) {
	  DialogBox(DLLInstance,"DLLABOUT",MultiDecWindow,DllAbout);
	} else if ( MenuID == 40001 ) {
	  Get_Current_Programm(&TPnr);
	} else if ( MenuID == 40002 ) {
	  Set_Current_Programm(2);
	} else if ( MenuID == 40003 ) {
	  Get_Programm_Detail(&TPtg);
	} else if ( MenuID == 40004 ) {
	  Set_Programm_Detail(&TPtg);
	} else if ( MenuID == 40005 ) {
	  Save_Programm_Liste();
	} else if ( MenuID == 40006 ) {
	  Rescan_Programm(&TPtg);
	} else if ( MenuID == 40010 ) {
	  Get_Current_Transponder(&TPtp);
	} else if ( MenuID == 40011 ) {
	  Set_Current_Transponder(&TPtp);
	} else if ( MenuID == 40020 ) {
	  Start_Log();
	} else if ( MenuID == 40021 ) {
      Stop_Log( );
	} else if ( MenuID == 40031 ) {
      Create_Osd_Thread((LPTHREAD_START_ROUTINE)Start_OSD_Key_Demo);
	} else if ( MenuID == 40032 ) {
      Create_Osd_Thread((LPTHREAD_START_ROUTINE)Start_OSD_Time_Demo);
	};
}


void On_Channel_Change( struct TProgramm CurrentProgramm )
{
char Zeile[128];

    sprintf(Zeile,"Kanalwechsel zu %s",CurrentProgramm.Name);
    MessageBox(MultiDecWindow,Zeile,"MultiDec DLL-DEMO",MB_OK);

}


void On_Hot_Key( void )
{
    MessageBox(MultiDecWindow,"HotKey der DLL gedrckt","MultiDec DLL-DEMO",MB_OK);

}


void On_Rec_Play(int Mode)
{
	if ( Mode == 1 ) {
    MessageBox(MultiDecWindow,"DLL -> Play gestartet","MultiDec DLL-DEMO",MB_OK);
	} else if ( Mode == 2 ) {
    MessageBox(MultiDecWindow,"DLL -> Record gestartet","MultiDec DLL-DEMO",MB_OK);
	} else if ( Mode == 3 ) {
    MessageBox(MultiDecWindow,"DLL -> Record/Play beendet","MultiDec DLL-DEMO",MB_OK);
	};
};

void On_Osd_Key( unsigned char Key )
{
    OSD_Key_Value=Key;
	if (OSD_KEY_EVENT != NULL ) SetEvent(OSD_KEY_EVENT);
}



void Set_Current_Transponder(struct TTransponder *Transponder)
{
	SendMessage(MultiDecWindow,WM_USER,MDAPI_SET_TRANSPONDER,(LONG)Transponder );
};

void Get_Current_Transponder(struct TTransponder *Transponder)
{
    char Zeile[128];
	SendMessage(MultiDecWindow,WM_USER,MDAPI_GET_TRANSPONDER,(LONG)Transponder );
    sprintf(Zeile,"Transpoder-Info -> freq  %10.3f",(float)Transponder->freq/1000 );
    MessageBox(MultiDecWindow,Zeile,"MultiDec DLL-DEMO",MB_OK);
};

void Get_Current_Programm( struct TProgrammNummer *TPNr )
{
    char Zeile[128];
	SendMessage(MultiDecWindow,WM_USER,MDAPI_GET_PROGRAMM_NUMMER,(LONG)TPNr);
    sprintf(Zeile,"Aktuelles Programm Nummer Real %d Virtuell %d",TPNr->RealNummer,TPNr->VirtNummer);
    MessageBox(MultiDecWindow,Zeile,"MultiDec DLL-DEMO",MB_OK);
};

void Set_Current_Programm( int Nummer )
{

	SendMessage(MultiDecWindow,WM_USER,MDAPI_SET_PROGRAMM_NUMMER,Nummer);
};

void Get_Programm_Detail( struct TProgramm *TPtg)
{
    char Zeile[128];
	SendMessage(MultiDecWindow,WM_USER,MDAPI_GET_PROGRAMM,(LONG)TPtg);
    sprintf(Zeile,"Programm-Info -> Name %s ->Anbieter %s",TPtg->Name,TPtg->Anbieter );
    MessageBox(MultiDecWindow,Zeile,"MultiDec DLL-DEMO",MB_OK);
};

void Set_Programm_Detail( struct TProgramm *TPtg)
{
	SendMessage(MultiDecWindow,WM_USER,MDAPI_SET_PROGRAMM,(LONG)TPtg );
}

void Save_Programm_Liste( void )
{
	SendMessage(MultiDecWindow,WM_USER,MDAPI_SAVE_PROGRAMM,0 );
}

void Rescan_Programm( struct TProgramm *TPtg)
{
    char Zeile[128];
	SendMessage(MultiDecWindow,WM_USER,MDAPI_GET_PROGRAMM,(LONG)TPtg);
    sprintf(Zeile,"Programm-Info -> Name %s ->Anbieter %s",TPtg->Name,TPtg->Anbieter );
    MessageBox(MultiDecWindow,Zeile,"MultiDec DLL-DEMO",MB_OK);
	SendMessage(MultiDecWindow,WM_USER,MDAPI_RESCAN_PROGRAMM,(LONG)TPtg );
    sprintf(Zeile,"Programm-Info -> Name %s ->Anbieter %s",TPtg->Name,TPtg->Anbieter );
    MessageBox(MultiDecWindow,Zeile,"MultiDec DLL-DEMO",MB_OK);
}


void Filter_0_Irq_Proc( int MyFilter, int DatenLaenge , unsigned char *Daten)
{

	// Was auch immer 
	// Achtung wenn diese Funktion abgearbeitet wird "hngt" die dvb-Karte. 
	// Bis zu return kommt kein IRQ mehr !!!! 
return;
}



void Start_Log( void )
{
    char Zeile[128];
	StartFilter.DLL_ID = MultiDec_DLL_ID;
    StartFilter.Filter_ID=0;                   // Mein Erster Filter maximal 8 ( 0..7 ) 
	StartFilter.Pid=0x0320;
	strcpy(StartFilter.Name,"Test DLL-Filter PID 0x0320");
	StartFilter.Irq_Call_Adresse=(DWORD)Filter_0_Irq_Proc;
	SendMessage(MultiDecWindow,WM_USER,MDAPI_START_FILTER,(LONG)&StartFilter);
    sprintf(Zeile,"StartFilter -> Running_ID %d",StartFilter.Running_ID );
    MessageBox(MultiDecWindow,Zeile,"MultiDec DLL-DEMO",MB_OK);

}

void Stop_Log( void )
{

	SendMessage(MultiDecWindow,WM_USER,MDAPI_STOP_FILTER,StartFilter.Running_ID);
    MessageBox(MultiDecWindow,"MDAPI_STOP_FILTER","MultiDec DLL-DEMO",MB_OK);
}

void On_Filter_Close(unsigned int FilterOffset )
{
 
	char Zeile[128];
	sprintf(Zeile,"MultiDec hat Filter Nr %d geschlossen",FilterOffset);
	
	MessageBox(MultiDecWindow,Zeile,"MultiDec DLL-DEMO",MB_OK);
}
void Create_Osd_Thread( LPTHREAD_START_ROUTINE ThreadProzess)
{
	DWORD LinkThreadID;
	if ( OSD_KEY_EVENT == NULL ) OSD_KEY_EVENT=CreateEvent(NULL,FALSE,FALSE,NULL);
    OSD_Key_Value=' ';
	ResetEvent(OSD_KEY_EVENT);
   
	CloseHandle(CreateThread ((LPSECURITY_ATTRIBUTES)NULL,       // No security.
                         			  (DWORD)0,                          // Same stack size.
                         			  ThreadProzess,// Thread procedure.
                         			  NULL,                         // Parameter.
                         			  (DWORD)0,                          // Start immediatly.
                         			  (LPDWORD)&LinkThreadID));  
};


void Start_OSD_Key_Demo( void )
{
char Zeile[128];

OSD_CreateWindow(1,200,30,500,180,TRUE);
OSD_Draw_Block( 0,  0,300,30,0);
OSD_Draw_Block( 0, 30,300,90,1);
OSD_Draw_Block( 0,120,300,30,0);
OSD_Set_Font( 1, 2, 0);
strcpy(Zeile,"API - Demo");
OSD_Write_Text( 90,1,Zeile);
strcpy(Zeile,"<0> Ende");
OSD_Write_Text( 100,121,Zeile);
OSD_Set_Font( 1, 2, 1);

	
	for (;;) {
    WaitForSingleObject (OSD_KEY_EVENT, INFINITE);
	ResetEvent(OSD_KEY_EVENT);
	if ( OSD_Key_Value == 0x00 ) {
                                 MessageBox(MultiDecWindow,"DLL-Thread OSD zu durch MultiDec","MultiDec DLL-DEMO",MB_OK);
		                      // MultiDec hat das Fenster geschlossen !!
		                         return;
								};
    OSD_Draw_Block( 0, 65,300,30,1);

    if ( OSD_Key_Value == '0' ) {
		                        strcpy(Zeile,"Ende");
								OSD_Write_Text( 100,65,Zeile);
								Sleep(1000);
								OSD_Close( );
                                return;
	};
       sprintf(Zeile,"Taste <%c>",OSD_Key_Value);
	   OSD_Write_Text( 100,65,Zeile);
	}

}

void Start_OSD_Time_Demo( void )
{
char Zeile[128];
int i;

OSD_CreateWindow(1,200,30,500,180,TRUE);
OSD_Draw_Block( 0,  0,300,30,0);
OSD_Draw_Block( 0, 30,300,90,1);
OSD_Draw_Block( 0,120,300,30,0);
OSD_Set_Font( 1, 2, 0);
strcpy(Zeile,"API - Demo");
OSD_Write_Text( 90,1,Zeile);
strcpy(Zeile,"Time-OSD");
OSD_Write_Text( 100,121,Zeile);
OSD_Set_Font( 1, 2, 1);

	i=10;
	for (;;) {
    WaitForSingleObject (OSD_KEY_EVENT, 1000 );
	ResetEvent(OSD_KEY_EVENT);
	if ( OSD_Key_Value == 0x00 ) {
                                 MessageBox(MultiDecWindow,"DLL-Thread OSD zu durch MultiDec","MultiDec DLL-DEMO",MB_OK);
		                      // MultiDec hat das Fenster geschlossen !!
		                         return;
								};
    OSD_Draw_Block( 0, 65,300,30,1);
    i--;
    sprintf(Zeile,"Ende in %02d Sek",i);
	OSD_Write_Text( 70,65,Zeile);
	if ( i == 0 ) {
								OSD_Close( );
                                return;
				};
	}

}

/**************** Usefull Helpers  ****************/


void OSD_CreateWindow(unsigned char Bits, unsigned short x1,unsigned short y1,unsigned short x2,unsigned short y2,BOOL Has_KeyBoard_Input)
{
	struct TOSD_START Osd_Start;


	// Bits 0 = 2 Farbige Fenstern ( knnen gr sein )
	// Bits 1 = 4 Farbige Fenster ( sollten klein sein ( Speicher auf DVBs Karte zu klein )


	Osd_Start.BitTiefe = Bits ;     // Kleine Fenster mit 4 Farben 
    Osd_Start.DLL_Id=MultiDec_DLL_ID;
	Osd_Start.x1=x1;
	Osd_Start.y1=y1;
	Osd_Start.x2=x2;
	Osd_Start.y2=y2;
	Osd_Start.Input=Has_KeyBoard_Input;        
	SendMessage(MultiDecWindow,WM_USER,MDAPI_START_OSD,(LONG)&Osd_Start);

};

void OSD_Draw_Block( unsigned short x,unsigned short y,unsigned short SizeX,unsigned short SizeY,unsigned short Color)
{
	struct TOSD_DRAW  Osd_Draw;
	Osd_Draw.x=x;
	Osd_Draw.y=y;
	Osd_Draw.Sizex=SizeX;    
	Osd_Draw.Sizey=SizeY;    
    Osd_Draw.Color=Color;
	SendMessage(MultiDecWindow,WM_USER,MDAPI_OSD_DRAWBLOCK,(LONG)&Osd_Draw);
};


void OSD_Set_Font( unsigned short Typ,unsigned short Fg_Color,unsigned short Bg_Color)
{
	struct TOSD_SETFONT  Osd_Set_Font;
	Osd_Set_Font.Typ=Typ;
	Osd_Set_Font.Fg_Color=Fg_Color;
	Osd_Set_Font.Bg_Color=Bg_Color;
	SendMessage(MultiDecWindow,WM_USER,MDAPI_OSD_SETFONT,(LONG)&Osd_Set_Font);
};

void OSD_Write_Text( unsigned short x,unsigned short y,unsigned char *Text)
{
	struct TOSD_SETEXT  Osd_Set_Text;
	Osd_Set_Text.x=x;
	Osd_Set_Text.y=y;
	strncpy(Osd_Set_Text.Zeile,Text,128);
	SendMessage(MultiDecWindow,WM_USER,MDAPI_OSD_TEXT,(LONG)&Osd_Set_Text);
};


void OSD_Close(  void )
{
	SendMessage(MultiDecWindow,WM_USER,MDAPI_STOP_OSD,0);
};

	


BOOL APIENTRY DllAbout(HWND hDlg,UINT message,UINT wParam,LONG lParam)
{
   
	switch (message) {
        case WM_INITDIALOG:
			break;
        case WM_COMMAND:
			if ((LOWORD(wParam) == IDOK ) || (LOWORD(wParam) == IDCANCEL )) {
				EndDialog(hDlg,TRUE);
			}
break;
    }

return(FALSE);
}
